=== debian/changelog ===
veracrypt (1.25.7-0.1~mx21+1) mx; urgency=medium

  * New upstream version 1.25.7.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 18 Jan 2022 10:49:07 -0800

veracrypt (1.25.4-0vanir1) unstable; urgency=medium

  * New upstream version 1.25.4.
    - Drop patch, upstreamed.
  * d/p/1001-port-to-libfuse3.patch: Port from libfuse2 to libfuse3.
  * d/scripts/mount.veracrypt, d/veracrypt.desktop, d/veracrypt.xml:
    - Drop, upstreamed.
  * d/control:
    - Replace libfuse-dev with libfuse3-dev.
    - Drop libappindicator3-dev as an alternate build-depend.4
    - Add exfatprogs as primary alternative to exfat-utils, which is fuse based
    - Bump DH compat to 13.
  * d/copyright: Update years.
  * d/gbp.conf: Drop '--controlmaint'.
  * d/rules:
    - Enable indicator support.
    - Drop '--as-needed' as it is now default in stable.
  * Update Standards-Version to 4.6.0.

 -- Unit 193 <unit193@unit193.net>  Sat, 04 Dec 2021 18:09:01 -0500

veracrypt (1.24-Update7-0vanir1) unstable; urgency=medium

  * New upstream version 1.24-Update7.
  * d/control, d/copyright: Update my email address and bump years.
  * d/gbp.conf: Pass '--controlmaint' to dch.

 -- Unit 193 <unit193@unit193.net>  Tue, 11 Aug 2020 01:43:24 -0400

veracrypt (1.24-Update4-0vanir1) unstable; urgency=medium

  * New upstream version 1.24-Update4
  * Update Standards-Version to 4.5.0.
  * d/compat, d/control:
    - Drop d/compat in favor of debhelper-compat, bump to 12.

 -- Unit 193 <unit193@ubuntu.com>  Mon, 27 Jan 2020 18:31:30 -0500

veracrypt (1.24-Update2-0vanir1) unstable; urgency=medium

  * d/prerm: Send error messages to STDERR.
  * New upstream version 1.24-Update2
    - Drop upstream patches, refresh remaining.

 -- Unit 193 <unit193@ubuntu.com>  Thu, 19 Dec 2019 17:59:06 -0500

veracrypt (1.24-Hotfix1-0vanir1) unstable; urgency=medium

  * New upstream version 1.24-Hotfix1
    - Refresh patches.
  * d/p/002-Fix_compilation_on_non-x86_platforms.patch:
    - Grab upstream commit to fix compilation on non-x86 platforms.
  * d/p/003-Fix_compilation_error_if_type___u64_already_defined.patch:
    - Fix compilation error if type __u64 is already defined by gcc.

 -- Unit 193 <unit193@ubuntu.com>  Wed, 30 Oct 2019 19:07:18 -0400
