=== debian/control ===
Source: veracrypt
Section: non-free/utils
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Unit 193 <unit193@unit193.net>
Build-Depends: debhelper-compat (= 12),
               libayatana-appindicator3-dev,
               libfuse3-dev,
               libwxgtk3.0-gtk3-dev,
               pkg-config,
               yasm [any-i386 any-amd64]
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://veracrypt.fr/

Package: veracrypt
Architecture: any
Depends: dmsetup, kmod, lsb-base, sudo, ${misc:Depends}, ${shlibs:Depends},
         exfatprogs | exfat-utils, ntfs-3g, xdg-utils
Description: Cross-platform on-the-fly encryption
 VeraCrypt provides cross-platform on-the-fly encryption for Linux, MacOS X and
 Windows. It can encrypt filesystems stored either within a file or on disk
 partitions. Supported encryption algorithms include AES, Serpent and Twofish.
 The current version uses the XTS mode of disk encryption. In addition,
 VeraCrypt supports "hidden volumes" - unidentifiable volumes present in the
 free-space of a VeraCrypt volume.
