=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export TC_EXTRA_CFLAGS = $(CFLAGS) $(CPPFLAGS)
export TC_EXTRA_CXXFLAGS = $(CXXFLAGS) $(CPPFLAGS)
export TC_EXTRA_LFLAGS = $(LDFLAGS)

%:
	dh  $@ --sourcedirectory=src

override_dh_auto_build:
	dh_auto_build -- ARCH=$(DEB_HOST_ARCH) INDICATOR=1 NOSTRIP=1 VERBOSE=1
	unset DISPLAY && src/Main/veracrypt --text --help 2>/dev/null | debian/veracrypt_help_to_troff.pl > veracrypt.1

override_dh_clean:
	dh_clean veracrypt.1

override_dh_install:
	dh_install
	rm -f debian/veracrypt/usr/share/doc/veracrypt/License.txt debian/veracrypt/usr/bin/veracrypt-uninstall.sh

override_dh_installinit:
	dh_installinit --no-start -- stop 10 0 1 6 .

override_dh_strip:
	dh_strip --no-automatic-dbgsym
