## veracrypt 1.25.9

=== Makefile ===
--- 
+++ 
@@ -143,6 +143,7 @@
 
 export CPU_ARCH ?= unknown
 export SIMD_SUPPORTED := 0
+export DISABLE_AESNI ?= 0
 
 ARCH ?= $(shell uname -m)
 
@@ -176,6 +177,9 @@
 	SIMD_SUPPORTED := 0
 endif
 
+ifeq "$(origin NOAESNI)" "command line"
+	DISABLE_AESNI := 1
+endif
 
 #------ Linux configuration ------
 
@@ -197,11 +201,16 @@
 		CFLAGS += -msse2
 		CXXFLAGS += -msse2
 
-		GCC_GTEQ_440 := $(shell expr `$(CC) -dumpversion | sed -e 's/\.\([0-9][0-9]\)/\1/g' -e 's/\.\([0-9]\)/0\1/g' -e 's/^[0-9]\{3,4\}$$/&00/' -e 's/^[0-9]\{1,2\}$$/&0000/'` \>= 40400)
-		GCC_GTEQ_430 := $(shell expr `$(CC) -dumpversion | sed -e 's/\.\([0-9][0-9]\)/\1/g' -e 's/\.\([0-9]\)/0\1/g' -e 's/^[0-9]\{3,4\}$$/&00/' -e 's/^[0-9]\{1,2\}$$/&0000/'` \>= 40300)
-		ifeq "$(GCC_GTEQ_440)" "1"
-			CFLAGS += -maes
-			CXXFLAGS += -maes
+		ifeq "$(DISABLE_AESNI)" "1"
+			CFLAGS += -mno-aes -DCRYPTOPP_DISABLE_AESNI
+			CXXFLAGS += -mno-aes -DCRYPTOPP_DISABLE_AESNI
+		else
+			GCC_GTEQ_440 := $(shell expr `$(CC) -dumpversion | sed -e 's/\.\([0-9][0-9]\)/\1/g' -e 's/\.\([0-9]\)/0\1/g' -e 's/^[0-9]\{3,4\}$$/&00/' -e 's/^[0-9]\{1,2\}$$/&0000/'` \>= 40400)
+			GCC_GTEQ_430 := $(shell expr `$(CC) -dumpversion | sed -e 's/\.\([0-9][0-9]\)/\1/g' -e 's/\.\([0-9]\)/0\1/g' -e 's/^[0-9]\{3,4\}$$/&00/' -e 's/^[0-9]\{1,2\}$$/&0000/'` \>= 40300)
+			ifeq "$(GCC_GTEQ_440)" "1"
+				CFLAGS += -maes
+				CXXFLAGS += -maes
+			endif
 		endif
 
 		ifeq "$(GCC_GTEQ_430)" "1"
@@ -365,8 +374,16 @@
 	endif
 
 	ifeq "$(SIMD_SUPPORTED)" "1"
-		CFLAGS += -msse2 -maes
-		CXXFLAGS += -msse2 -maes
+		CFLAGS += -msse2
+		CXXFLAGS += -msse2
+		
+		ifeq "$(DISABLE_AESNI)" "1"
+			CFLAGS += -mno-aes -DCRYPTOPP_DISABLE_AESNI
+			CXXFLAGS += -mno-aes -DCRYPTOPP_DISABLE_AESNI
+		else
+			CFLAGS += -maes
+			CXXFLAGS += -maes
+		endif
 
 		ifeq "$(origin SSSE3)" "command line"
 			CFLAGS += -mssse3
@@ -433,6 +450,3 @@
 ifdef VC_WX_MINIMAL
 WX_CONFIGURE_FLAGS += --disable-protocol --disable-protocols --disable-url --disable-ipc --disable-sockets --disable-fs_inet --disable-ole --disable-docview --disable-clipboard \
 	--disable-help --disable-html --disable-mshtmlhelp --disable-htmlhelp --disable-mdi --disable-metafile --disable-webkit --disable-webview \
-	--disable-xrc --disable-aui --disable-postscript --disable-printarch \
-	--disable-arcstream --disable-fs_archive --disable-fs_zip --disable-tarstream --disable-zipstream \
-	--disable-animatectrl --disable-bmpcombobox --disable-calendar --disable-caret --disable-checklst --disable-collpane --disable-colourpicker --disable-comboctrl \
