=== debian/changelog ===
veracrypt (1.25.9-0mx23) mx; urgency=medium

  * Rebuild for MX-23

 -- Timothy E. Harris <maintainer@mxrepo.com>  Mon, 29 May 2023 17:24:59 -0400

veracrypt (1.25.9-0vanir1~bpo22.10) kinetic; urgency=medium

  * No-change backport to kinetic.

 -- Unit 193 <unit193@ubuntu.com>  Thu, 20 Oct 2022 08:42:04 -0400

veracrypt (1.25.9-0vanir1) unstable; urgency=medium

  * New upstream version 1.25.9.

 -- Unit 193 <unit193@unit193.net>  Thu, 10 Mar 2022 22:56:27 -0500

veracrypt (1.25.7-0vanir1) unstable; urgency=medium

  * New upstream version 1.25.7.
  * d/copyright: Update years.

 -- Unit 193 <unit193@unit193.net>  Tue, 01 Feb 2022 03:03:30 -0500
