=== debian/rules ===
--- 
+++ 
@@ -27,6 +27,3 @@
 
 override_dh_installinit:
 	dh_installinit --no-start -- stop 10 0 1 6 .
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
