=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.sig/ \
https://sf.net/veracrypt/[Vv]era[Cc]rypt_([\d\w\._-]+)_[Ss]ource\.tar\.(?:gz|bz2|xz)
