## veracrypt 1.26.7

=== Boot/Windows/Makefile ===
--- 
+++ 
@@ -46,7 +46,7 @@
 OBJDIR = $(OBJDIR)_$(SINGLE_PRF)
 CFLAGS = $(CFLAGS) /D TC_WINDOWS_BOOT_$(SINGLE_PRF)
 !else
-CFLAGS = $(CFLAGS) /D TC_WINDOWS_BOOT_RIPEMD160
+CFLAGS = $(CFLAGS) /D TC_WINDOWS_BOOT_BLAKE2S
 !endif
 
 OUTDIR = $(OBJDIR)
@@ -85,7 +85,7 @@
 !if "$(SINGLE_PRF)" == "SHA2"
 OBJS = $(OBJS) $(OUTDIR)\Sha2Small.obj
 !else
-OBJS = $(OBJS) $(OUTDIR)\Rmd160.obj
+OBJS = $(OBJS) $(OUTDIR)\blake2s-ref.obj
 !endif
 
 !if !DEFINED (SINGLE_CIPHER)
