=== debian/changelog ===
veracrypt (1.26.7-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 28 May 2024 16:33:50 -0700

veracrypt (1.26.7-0vanir1~bpo22.04) jammy; urgency=medium

  * No-change backport to jammy.

 -- Unit 193 <unit193@ubuntu.com>  Tue, 03 Oct 2023 03:58:57 -0400

veracrypt (1.26.7-0vanir1) unstable; urgency=medium

  * New upstream version 1.26.7.
    - Drop upstream patch, refresh remaining.
  * d/p/1002-fix-ftbfs-32bit.patch: Nab commit to fix ftbfs on 32bit.
  * d/control: Build-Depend on libpcsclite-dev.
  * d/copyright: Update attribution.
  * d/NEWS: Warn of TrueCrypt support removal.

 -- Unit 193 <unit193@unit193.net>  Tue, 03 Oct 2023 03:12:59 -0400

veracrypt (1.25.9-0vanir2) unstable; urgency=medium

  * d/control:
    - Add libwxgtk3.2-dev as primary alternative.
    - Drop lsb-base from depends.
  * d/p/1002-silence-asserts.patch: Add upstream patch to silence asserts.
  * Update Standards-Version to 4.6.2.

 -- Unit 193 <unit193@unit193.net>  Sat, 09 Sep 2023 03:14:39 -0400
